﻿@page "/"
@using BlazorRadzen.Code
@inject MobiData MobiData

<RadzenChart>
    @foreach (var (key, data) in Data) 
    {
        <RadzenLineSeries
            Interpolation="@Interpolation.Step"
            Title="@key"
            Data="@(new List<DataItem>(data))"
            CategoryProperty="@nameof(DataItem.Date)"
            ValueProperty="@nameof(DataItem.Value)"/>
    }
    <RadzenCategoryAxis FormatString="{0:H:mm:ss}"/>
    <RadzenValueAxis Min="-12" Max="+12">
        <RadzenGridLines Visible="true"/>
    </RadzenValueAxis>
    <RadzenChartTooltipOptions Visible="false"/>
</RadzenChart>

@code 
{
    private class DataItem
    {
        public DateTime Date { get; set; }
        public double Value { get; set; }
    }
    
    private Dictionary<string, List<DataItem>> Data { get; } = new()
    {
        ["sin"] = new List<DataItem>(),
        ["cos"] = new List<DataItem>()
    };

    protected override async void OnAfterRender(bool firstRender)
    {
        if (firstRender)
        {
            using var periodicTimer = new PeriodicTimer(TimeSpan.FromMilliseconds(16));
            while (await periodicTimer.WaitForNextTickAsync())
            {
                Add(Data["sin"], MobiData.Active);
                Add(Data["cos"], MobiData.Update);

                await InvokeAsync(StateHasChanged);
            }
        }
    }

    private void Add(List<DataItem> list, double value)
    {
        list.Add(new DataItem
        {
            Date = DateTime.Now,
            Value = value
        });
        
        if (list.Count > 100)
        {
            list.Remove(list.MinBy(d => d.Date)!);
        }
    }
}